$Comment = "#"; #Use this to execute test
#$Comment =  ""; #Use this if using output to create test script
$Total = 0;
my($Line);

sub DoTestInitialise {
        $Expected = shift(@_);

        #Merely report how many result we expect if actually testing
        if ($Comment ne "") {
                &Expect($Expected);
                return 1;
        }

        #Creating script: copy header lines up to __END__ to output
        open(SCRIPT, "<" .  $0);
        while (<SCRIPT>) {
                print $_;
                last if /^\s*__END__/;
        }

        close(SCRIPT);

        #Copy data lines until first test line found
        $Line = <DATA>;
        for (;;) {
                last if $Line =~ /^-/;
                last if eof(DATA);
                print $Comment, $Line;
                $Line = <DATA>;
        }


} #DoTestInitialise

sub DoTest {
        #Skip blank lines and insist that test lines start with -
        for (;;) {
                last if $Line =~ /^-/;
                last if eof(DATA);

                $Line = <DATA>;
                last if $Line =~ /^-/;
                last if eof(DATA);

                print $Comment, $Line;
                chomp($Line);
                $Line =~ s/^\s+//;
                next if $Line =~ /^$/;
                next if $Line =~ /^;/;

                last;

        }
        return 0 if eof(DATA);

        die("Unknown: $Line\n") if $Line !~ /^-/;

        #Found test -- execute it and compare result to file
        print $Comment, $Line;
        $Total++;
        $Line =~ s/^- *//;
        $Test = $Line;
        $Test =~ s/\$TestProg/$TestProg/;
        open(RESULT, "$Test |");
        while (<RESULT>) {
                print $Comment, $_;
                next if $Comment eq "";
                $Expected = <DATA>;
                $_ =~ s/ +$//;
                $Expected =~ s/ +$//;
                next if $_ eq $Expected;

                print $Comment, "expected: ", $Expected;

                die("mismatched");

        }

        #Get next line of test script
        $Line = <DATA>;

        #Skip to next test line (starting with -) if creating
        if ($Comment eq "") {
                while ($Line = <DATA>) {
                        last if $Line =~ /^-/;
                        last if eof(DATA);
                }

                #Add a blank line as this script is a little finicky
                print "\n";

        } else {
                #Actual test: report that results were correct
                &Ok($Total);
        }

        1;

} #DoTest

sub DoTestFinalise {

        print "#Total: $Total\n";

} #DoTestFinalise

1;

