$FALSE = 0;
$TRUE = 1;

$GGREPHOME = "/home/bjh/grep/ggrep";
$TestProg = "$GGREPHOME/src/ggrep";


sub Expect {
	local ($NrToExpect) = @_;
	print "1..$NrToExpect\n";
	1;
}

sub Ok {
	local($TestNr) = @_;
	print "ok $TestNr\n";
	1;
}

sub NotOk {
	local($TestNr) = @_;
	print "not ok $TestNr\n";
	1;
}

sub FilesSame {
	local ($new, $old) = @_;

	return 0 unless -e $new;
	return 0 unless -e $old;

	open(N, $new);
	open(O, $old);

	local($same) = 1;
	for (;;) {
		if (<N> != <O>) {
			$same = 0;
			last;
		}

		if (eof(N)) {
			last;
		}

	}
	
	close(N);
	close(O);

	$same;

}

##########################################################################
# CopyScript -- Add script text to output to aid test generation
sub CopyScript {
        open(SCRIPT, $0);
        while (<SCRIPT>) {
                print $_;

                last if /^\s*__END__/;

        }

        close(SCRIPT);

} #CopyScript

1;

